require "defines"

script.on_event(defines.events.on_built_entity, function(event)
	local entity = event.created_entity
	
	if global.var == nil then
		global.var = entity
	else
		drawLine(global.var.position, entity.position, entity.surface)
		global.var = nil
	end
end)


function drawLine(positionStart, positionEnd, surface)
	
	--Find the total distance in each X and Y that has to be travelled
	local xDistance = -(positionStart.x - positionEnd.x)
	local yDistance = -(positionStart.y - positionEnd.y)
	
	--Find the total distance of the line
	local distance = math.sqrt((xDistance^2) + (yDistance^2))
	
	--How close is each dot of the line?
	local size = 1/32
	
	--Find the number of steps to draw the line
	local steps = math.ceil(distance/size)
	
	--Find the distance between each step
	local xStepDistance = xDistance/steps
	local yStepDistance = yDistance/steps
	
	--Start position
	local xPlacement = positionStart.x
	local yPlacement = positionStart.y
	
	--For each step, place a dot step distance closer to the end point
	for i=0, steps do
		surface.create_entity{name="draw-line-dot", position={xPlacement+(i*xStepDistance), yPlacement+(i*yStepDistance)}}
	end
end